from django.contrib import admin

from games.models import Developer, Game, GameSystem, Genre, Publisher, GameCollection


class GameAdmin(admin.ModelAdmin):
    list_display = ("name", "game_system", "rating", "region")
    list_filter = ("game_system", "undub", "english_patched", "hack")

class GameInline(admin.TabularInline):
    model = Game

class GameCollectionAdmin(admin.ModelAdmin):
    filter_horizontal = ('games',)
    raw_id_fields = ('game_system', 'developer', 'publisher', 'genre',)


admin.site.register(GameCollection, GameCollectionAdmin)
admin.site.register(GameSystem)
admin.site.register(Developer)
admin.site.register(Publisher)
admin.site.register(Genre)
admin.site.register(Game, GameAdmin)
