from django.urls import path

import games.views as views

app_name = "games"

urlpatterns = [
    path(
        "",
        views.RecentGameList.as_view(),
        name="game_list",
    ),
    path(
        "library/",
        views.LibraryGameList.as_view(),
        name="game_library_list",
    ),
    path(
        "publisher/",
        views.PublisherList.as_view(),
        name="publisher_list",
    ),
    path(
        "genre/",
        views.GenreList.as_view(),
        name="genre_list",
    ),
    path(
        "developer/",
        views.DeveloperList.as_view(),
        name="developer_list",
    ),
    path(
        "collection/",
        views.GameCollectionList.as_view(),
        name="gamecollection_list",
    ),
    path(
        "<str:slug>/",
        views.GameDetail.as_view(),
        name="game_detail",
    ),
    path(
        "<str:slug>/play/",
        views.GamePlayDetail.as_view(),
        name="game_play_detail",
    ),
    path(
        "system/<str:slug>/",
        views.GameSystemDetail.as_view(),
        name="game_system_detail",
    ),
    path(
        "genre/<str:slug>/",
        views.GenreDetail.as_view(),
        name="genre_detail",
    ),
    path(
        "publisher/<str:slug>/",
        views.PublisherDetail.as_view(),
        name="publisher_detail",
    ),
    path(
        "developer/<str:slug>/",
        views.DeveloperDetail.as_view(),
        name="developer_detail",
    ),
    path(
        "collection/<str:slug>/",
        views.GameCollectionDetail.as_view(),
        name="gamecollection_detail",
    ),
]
